Compare commits

...

10 Commits

Author SHA1 Message Date
0a428d8756 update_psa():
if called without -m (without MAINTENANCE):
check for ISMAS updates 3 times. If no response by ISMAS, end update process with FAILURE (exit script)
if called with -m:
check for ISMAS updates 10 times. If no response by ISMAS, end update process with FAILURE (exit script)
2023-06-29 13:38:41 +02:00
1ecabe79ca fetch_customer_updates(): add debug output.
check_for_running_apism(): use port 7777 instead of port 7778.
2023-06-29 13:36:56 +02:00
3affefe82a Remove usage of the following variables:
TARIFF_CURRENT
TARIFF_SUMMER
TARIFF_WINTER
TC_PSA_TC_FILE
TC_SYS_TC_FILE
2023-06-29 13:34:24 +02:00
a957894d9a Removed usage of obsolete variable TC_PSA_TC_FILE (=tariff.current) and
ATBQT_ATB_SYS_BIN_FILE.
For ATBQT_ATB_SYS_BIN_FILE use /opt/app/ATBAPP/ATBQT directly.
2023-06-29 13:30:37 +02:00
0e7f5938c7 1: Wait 5 seconds for ISMAS response.
2: For ISMAS response: check if device_id (=machine_nr) sent from ISMAS
is the same as the local machine_nr. If NO, return 1 (fail).
2023-06-29 13:27:01 +02:00
fcf179bee1 clone_customer_repository(): add additional debug-output. 2023-06-29 13:23:51 +02:00
f7badfea2e Add empty_file()-helper. To be used later. 2023-06-29 13:22:19 +02:00
4921cb9f06 Merge branch 'master' of https://git.mimbach49.de/GerhardHoffmann/UpdateController 2023-06-20 09:15:14 +02:00
ff2ea6b8f2 Check sanity of WORKING_DIRECTORY variable. cd into $WORKING_DIRECTORY before sourcing other scripts. 2023-06-20 09:14:20 +02:00
0cbd5f523f „update_psa.conf“ ändern
Fix: path to machine_nr in config file
2023-06-09 17:24:51 +02:00
9 changed files with 75 additions and 35 deletions

View File

@ -115,4 +115,12 @@ if [ "${general_utils_sourced:-1}" = "1" ]; then # include only once
# log_debug "$1=$__n"
:
}
empty_file () {
if [[ -f "$1" ]]; then
echo -n "" > $1
else
log_error "$1 does not exist"
fi
}
fi

View File

@ -155,6 +155,8 @@ clone_customer_repository () {
fi
cd_home
log_info "$func:${LINENO} nach cd_home $PWD"
}
# clone_customer_repository ->
# https://git.mimbach49.de/GerhardHoffmann/customer_281.git

View File

@ -9,13 +9,27 @@ if [ "${news_from_ismas_sourced:-1}" = "1" ]; then # include only once
updates_available () {
local func="${FUNCNAME[0]}"
local json_response="$((echo -n '#M=APISM #C=REQ_ISMASParameter #J={}';
sleep 1) | nc localhost $APISM_DIRECT_PORT)"
sleep 5) | nc localhost $APISM_DIRECT_PORT)"
if [ $? -eq 0 ]; then
local trigger="$(echo $json_response | jq -r .Fileupload.TRG)"
log_debug "$func:${LINENO}: apism_trigger=\"$trigger\""
grep -qE "WAIT" <<< "$trigger" && return 0
local ismas_device_id="$(echo $json_response | jq -r .Dev_ID.Device_ID)"
local machine_nr=$(cat "/etc/machine_nr")
log_info "$func:${LINENO}: json_response=$json_response"
log_info "$func:${LINENO}: apism_trigger=<$trigger> device_id=<$ismas_device_id> machine_nr=<$machine_nr>"
if [ ! -z "$ismas_device_id" -a "$ismas_device_id" != " " ]; then
if [ ! -z "$machine_nr" -a "$machine_nr" != " " ]; then
if [ "$ismas_device_id" != "$machine_nr" ]; then
log_error "$func:${LINENO}: ISMAS DEVICE ID <$ismas_deviceId> != LOCAL_MACHINE_NUMBER <$machine_nr>"
return 1
fi
fi
fi
if grep -qE "WAIT" <<< "$trigger"; then
log_info "$func:${LINENO}: FOUND WAIT TRIGGER"
return 0
fi
else
log_error "$func:${LINENO}: apism request failed"
log_error "$func:${LINENO}: APISM REQUEST FAILED"
fi
return 1
}
@ -23,11 +37,11 @@ if [ "${news_from_ismas_sourced:-1}" = "1" ]; then # include only once
update_status () {
local func="${FUNCNAME[0]}"
local json_response="$((echo -n '#M=APISM #C=REQ_ISMASParameter #J={}';
sleep 1) | nc localhost $APISM_DIRECT_PORT)"
sleep 5) | nc localhost $APISM_DIRECT_PORT)"
local trigger=""
if [ $? -eq 0 ]; then
trigger="$(echo $json_response | jq -r .Fileupload.TRG)"
log_debug "$func:${LINENO}: apism_trigger=\"$trigger\""
log_info "$func:${LINENO}: apism_trigger=<$trigger>"
else
log_error "$func:${LINENO}: apism request failed"
fi

View File

@ -396,7 +396,6 @@ if [ "${news_to_ismas_sourced:-1}" = "1" ]; then # include only once
\"HASH\":\"$(compute_hash)\"
},
\"TARIFF\" : {
$(<$TC_PSA_TC_FILE)
},
\"HARDWARE\" : {
\"DEVICES\" : [
@ -425,10 +424,10 @@ if [ "${news_to_ismas_sourced:-1}" = "1" ]; then # include only once
\"RAUC\" : \"$(rauc --version)\",
\"OPKG\" : \"$(opkg --version)\",
\"ATBQT\" : {
\"VERSION\" : \"$($ATBQT_ATB_SYS_BIN_FILE -v |
\"VERSION\" : \"$(/opt/app/ATBAPP/ATBQT -v |
grep Version |
sed -E -e 's/.*:\s*(.*)/\1/g')\",
\"GIT_DESCRIBE\" : \"$($ATBQT_ATB_SYS_BIN_FILE -v |
\"GIT_DESCRIBE\" : \"$(/opt/app/ATBAPP/ATBQT -v |
grep git |
sed -E -e 's/.*:\s*(.*)/\1/g')\"
},

View File

@ -132,11 +132,11 @@ if [ ${read_config_sourced:-1} = "1" ]; then # include only once
check_sanity_of_repository () {
local func="${FUNCNAME[0]}"
if [ "$PWD" != "$WORKING_DIRECTORY" ]; then
log_fatal "$func:${LINENO} PD != WD ($PWD != $WORKING_DIRECTORY)"
fi
assert_d CUSTOMER_ID_BASE_DIR
CUSTOMER_LOCATION_DIR="$CUSTOMER_ID_BASE_DIR"
@ -168,7 +168,6 @@ if [ ${read_config_sourced:-1} = "1" ]; then # include only once
# readonly CUST_BASE_DIRS=(${__customer_base_dirs[@]})
# assert_a CUST_BASE_DIRS
readonly CUST_BASE_DIR="$CUSTOMER_ID_BASE_DIR"
#readonly CUST_BASE_DIR="${CUST_BASE_DIRS[$ZONE]}"
#assert_d CUST_BASE_DIR
@ -202,10 +201,7 @@ if [ ${read_config_sourced:-1} = "1" ]; then # include only once
readonly ISMASMGR_INI="ISMASMgr.ini"
readonly SYSCONF_INI="sysconfig.ini"
readonly SYSCTRL_INI="SystemControl.ini"
readonly TARIFF_CURRENT="tariff.current"
readonly DC="dc2c.bin"
readonly TARIFF_SUMMER="summer_tariff.json"
readonly TARIFF_WINTER="winter_tariff.json"
readonly DC_SYS_DC_FILE="${DC_SYS_DIR}/$DC"
readonly ATBQT_ATB_SYS_BIN_FILE="${ATBAPP_SYS_DIR}/$ATBQT_BIN"
@ -224,14 +220,11 @@ if [ ${read_config_sourced:-1} = "1" ]; then # include only once
readonly SYSCTRL_SCF_SYS_INI_FILE="${SYSCONFIG_SYS_DIR}/$SYSCTRL_INI"
# readonly ZONE_FILE="$ETC_SYS_DIR/zone_nr"
readonly CUST_ID_FILE="$ETC_SYS_DIR/cust_nr"
readonly TC_SYS_TC_FILE="${ATBAPP_SYS_DIR}/$TARIFF_CURRENT"
readonly OPKG_CMDS_SYS_FILE="${OPKG_SYS_DIR}/opkg_commands"
readonly DC2C_SYS_SERIAL_JSON="${CONF_SYS_DIR}/DC2C_serial.json"
readonly DC2C_SYS_CASH_JSON="${CONF_SYS_DIR}/DC2C_cash.json"
readonly DC2C_SYS_CONF_JSON="${CONF_SYS_DIR}/DC2C_conf.json"
readonly DC_PSA_DC_FILE="${DC_PSA_DIR}/$DC"
readonly TARIFF_SYS_SUMMER="${TARIFF_SYS_DIR}${TARIFF_SUMMER}"
readonly TARIFF_SYS_WINTER="${TARIFF_SYS_DIR}${TARIFF_WINTER}"
readonly ATBQT_ATB_PSA_INI_FILE="${ATB_PSA_DIR}/$ATBQT_INI"
readonly ATBQT_APP_PSA_INI_FILE="${ATBAPP_PSA_DIR}/$ATBQT_INI"
@ -247,7 +240,6 @@ if [ ${read_config_sourced:-1} = "1" ]; then # include only once
readonly SYSCTRL_ATB_PSA_INI_FILE="${ATB_PSA_DIR}/$SYSCTRL_INI"
readonly SYSCTRL_SCF_PSA_INI_FILE="${SYSCONFIG_PSA_DIR}/$SYSCTRL_INI"
readonly OPKG_CMDS_PSA_FILE="${OPKG_PSA_DIR}/opkg_commands"
readonly TC_PSA_TC_FILE="${ATBAPP_PSA_DIR}/$TARIFF_CURRENT"
# readonly PSA_UPDATE_CONF="${CUSTOMER_LOCATION_DIR}/update.conf"
readonly DC2C_PSA_SERIAL_JSON="${CONF_PSA_DIR}/DC2C_serial.json"
readonly DC2C_PSA_CASH_JSON="${CONF_PSA_DIR}/DC2C_cash.json"
@ -294,7 +286,6 @@ if [ ${read_config_sourced:-1} = "1" ]; then # include only once
assert_f SYSCTRL_ETC_SYS_INI_FILE
assert_f SYSCTRL_ATB_SYS_INI_FILE
assert_f SYSCTRL_SCF_SYS_INI_FILE
assert_f TC_SYS_TC_FILE
assert_f OPKG_CMDS_SYS_FILE
assert_f DC2C_SYS_CONF_JSON
assert_f DC2C_SYS_SERIAL_JSON
@ -314,7 +305,6 @@ if [ ${read_config_sourced:-1} = "1" ]; then # include only once
assert_f SYSCTRL_ETC_PSA_INI_FILE
assert_f SYSCTRL_ATB_PSA_INI_FILE
assert_f SYSCTRL_SCF_PSA_INI_FILE
assert_f TC_PSA_TC_FILE
# assert_f PSA_UPDATE_CONF
assert_f OPKG_CMDS_PSA_FILE
assert_f DC2C_PSA_CONF_JSON

View File

@ -70,7 +70,19 @@ while test $# -gt 0; do
esac
shift
done
if [ -z "$WORKING_DIRECTORY" ]; then
echo "WORKING_DIRECTORY empty. exiting..."
exit 1
fi
if [ ! -d "$WORKING_DIRECTORY" ]; then
echo "WORKING_DIRECTORY $WORKING_DIRECTORY does not exist! exiting..."
exit 1
fi
cd "$WORKING_DIRECTORY"
source ./update_psa_impl
if read_config; then

View File

@ -19,7 +19,7 @@
"customer_id_" : "/etc/cust_nr",
"" : "machine id of PSA",
"machine_nr" : "/etc/mach_nr",
"machine_nr" : "/etc/machine_nr",
"" : "each location can have multiple",
"" : "zone-groups and/or zones",

View File

@ -24,9 +24,12 @@ exec_opkg_command () {
# Fetch/merge updates from predefined repository using git.
#
fetch_customer_updates() {
local func="${FUNCNAME[0]}"
if ! pull_customer_repository; then
log_warn "$func:${LINENO} NO pull_customer_repository"
return 1
fi
log_debug "$func:${LINENO} pull_customer_repository SUCCESS"
return 0
}
@ -375,7 +378,7 @@ cleanup_previous_version() {
check_for_running_apism () {
local func="${FUNCNAME[0]}"
if nc localhost 7778
if nc localhost 7777
then
APISM_RUNNING=1
log_info "$func:${LINENO}: APISM is running..."

View File

@ -45,36 +45,48 @@ update_psa() {
check_sanity_of_repository
$INITIAL_CLONE && return 0
local ismas_requests=0
if [ "$MAINTENANCE" = "NO" ]; then
log_info "update_psa:${LINENO}: MAINTENANCE OFF. Checking for updates..."
log_info "${func}:${LINENO}: MAINTENANCE OFF. Checking for updates..."
# someone must have activated the WAIT-button in ISMAS.
# Request the status of this button in updates_available().
if ! updates_available; then
update_psa_false_alarm "update requested, but no WAIT state detected !!!"
while [ $ismas_requests -le 3 ]; do
ismas_requests=$(( $ismas_requests + 1 ))
updates_available && break
update_psa_false_alarm "update requested, but no WAIT state detected <$ismas_requests>"
done
if [ $ismas_requests -gt 3 ]; then
log_fatal "update_psa:${LINENO}: update requested, but no WAIT state detected !!!"
fi
else
# simulate an activated WAIT-button
log_info "${func}:${LINENO}: MAINTENANCE ON. Emulate ISMAS updates..."
# simulate an activated WAIT-button in ISMAS
set_updates_available
while :
do
while [ $ismas_requests -le 10 ]; do
sleep 5
updates_available && break
ismas_requests=$(( $ismas_requests + 1 ))
log_info "${func}:${LINENO}: updates_requested <$ismas_requests>"
done
if [ $ismas_requests -gt 10 ]; then
log_fatal "${func}:${LINENO}: NO ISMAS UPDATES AVAILABLE"
fi
fi
log_debug "$func:${LINENO}: fetch/merge updates..."
log_debug "$func:${LINENO}: before fetch/merge updates..."
# Fetch new updates (using git). but only when repository has already been
# cloned.
if ! fetch_customer_updates; then
log_error "$func:${LINENO}: fetch no data for $customer_id"\
"-> no files to update -> no psa update"
update_psa_false_alarm \
"update request, but no change in $CUSTOMER_REPOSITORY_PATH"
# TODO
log_fatal "$func:${LINENO}: fetch no data for $customer_id"\
"-> no files to update -> no psa update"
else
log_debug "$func:${LINENO}: after successful fetch_customer_repository..."
fi
update_psa_pull_customer_repository # message to ISMAS
}